#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "pic.h"
#include "intelHex.h"
#include "main.h"
#include "lowlvl.h"

extern GtkWidget *window1;
GtkWidget *filedialog;
GtkWidget *statusbar;
GtkWidget *fichero;
GtkWidget *texto;

void on_butCargarHex_clicked (GtkButton       *button, gpointer         user_data)
{
	// Creamos el dialogo de seleccin de archivos
	filedialog=create_fileselection1(); 
   	gtk_widget_hide( window1 ); // escondemos la ventana principal
   	gtk_widget_show( filedialog ); // mostramos el nuevo dialogo

}


void on_butMostrarRAM_clicked (GtkButton       *button, gpointer         user_data)
{
	edit_pic(); // de pic.h
}

void on_butLlenarRAM_clicked (GtkButton       *button, gpointer         user_data)
{
	init_pic(); // de pic.h
	statusbar= lookup_widget( window1, "statusbar1");
	// Mostramos mensaje en la barra de estado
	gtk_statusbar_push(GTK_STATUSBAR(statusbar), (guint) &user_data, "Buffer llenado con 0xFFFF. Programe el PIC a continuacin.");
}


void on_butVolcarRAM_clicked (GtkButton       *button, gpointer         user_data)
{
	char *file;
	statusbar= lookup_widget( window1, "statusbar1");
	fichero = lookup_widget( window1, "entry1");
	file = gtk_entry_get_text(fichero); // cogemos el texto de la caja de texto
	if (write_file(file))			// de pic.h
	{
		// Mostramos mensaje en la barra de estado
		gtk_statusbar_push(GTK_STATUSBAR(statusbar), (guint) &user_data, "Fichero escrito correctamente.");
	}			
	else 
			gtk_statusbar_push(GTK_STATUSBAR(statusbar), (guint) &user_data, "ERROR escribiendo en el fichero.");
		
}


void on_butVolcarPIC_clicked (GtkButton       *button, gpointer         user_data)
{
		read_pic(); // de lowlvl.h
		statusbar= lookup_widget( window1, "statusbar1");
	  // Mostramos mensaje en la barra de estado
	  gtk_statusbar_push(GTK_STATUSBAR(statusbar), (guint) &user_data, "PIC leido. Para ver el contenido, usa el botn de VerBuffer.");
}


void on_butProgramar_clicked  (GtkButton       *button, gpointer         user_data)
{
	program_pic(); // de lowlvl.h
	gtk_statusbar_push(GTK_STATUSBAR(statusbar), (guint) &user_data, "El PIC ha sido programado.");
}


// Dialogo de FileSelection 
void on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  char *fileName;
  FILE *infile;
  int min,max;
	
	fileName = gtk_file_selection_get_filename( GTK_FILE_SELECTION( filedialog ) );
  // fileName contendr la ruta del fichero elegido 		
  gtk_widget_hide( filedialog ); // escondemos el dialogo 
  gtk_widget_show( window1 ); // mostramos la ventana principal
		
	texto = lookup_widget( window1, "text1" ); // "cogemos" el widget de window1 para asignarlo a la nueva variable
	gtk_editable_delete_text(GTK_EDITABLE(texto),0,-1); // borramos el conenido de la caja de texto
			
	if ( (infile = fopen(fileName,"rb")) == NULL )// Abrimos el fichero en modo solo-lectura
	{
		g_print("ERROR Abriendo el fichero");
		return;
	}
	
	min = 0;
	max = MAXPICSIZE;
	if (readihex(infile,pic.mem,&min,&max)==FALSE){
			fclose(infile);
			g_print("ERROR readihex");
			return;
	}
	
	fclose(infile); // cerramos el fichero
	
	edit_pic(); // de pic.h. Muestra en el cuadro de texto el contenido de la RAM
							// que contendr el archivo cargado anteriormente
	
	gtk_widget_destroy( filedialog ); // destruimos el dialogo que habiamos escondido
	
	statusbar= lookup_widget( window1, "statusbar1");
	gtk_statusbar_push(GTK_STATUSBAR(statusbar), (guint) &user_data, "Archivo cargado en el buffer. Programa el PIC a continuacin");
} 


void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide( filedialog );
   gtk_widget_show( window1 ); // mostramos la pantalla principal
   gtk_widget_destroy( filedialog ); // destruimos el dialogo anterior
}



void
destroyapp (GtkWidget *window1, gpointer user_data)
{
	g_print("\nSaliendo... :wq! \n");
	gtk_main_quit();
	
}


void
on_butSalir_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	g_print("\nSaliendo... :wq! \n");
	gtk_main_quit();
}




