#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "pic.h"
#include "lowlvl.h"
#include "main.h"


GtkWidget *window1;


int main (int argc, char *argv[])
{

  // Leemos la configuracin de ~/.picprgrc
  read_config(); // de pic.h

  // Inicializamos el buffer a 0xFFFF	
  init_pic(); // de pic.h

  // Recogemos info sobre los puertos paralelos
	// a partir del archivo /proc/ioports
  init_lp_table(); // de lowlvl.h

  // Intentamos ver si los puertos son "accesibles"
  if ( !init_port() )
  {
    g_print("ERROR al inicializar el puerto /dev/lp%d\n", pconfig.port );
    exit( -1 );
  }

  // Inicializamos todas las lineas de control a Off
  vppoff();
  vddoff();
  clklo();
  outlo();	
	
  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  window1 = create_window1 ();
  gtk_widget_show (window1);

  gtk_main ();
	
  // Volvemos a dejar todo en off
  vppoff();
  vddoff();
  clklo();
  outlo();

  // Guardamos la configuracin en .unipicrc
	write_config(); // de pic.h
	
	return 0;
}

